<?php
/***********************************
 * auther : bassam essa [bastr3]
 * email : bassam.a.a.r[at]gmail.com
 * UrOrbit Framework v.1
 */
    $_SESSION['all_paths_replace']=array(
        '%template:path%'=>$TEMPLATE_link,
        '%plugin:path%'=>PLUGIN_PATH,
        '%site:path%'=>SITE_LINK,
        '%upload:path%'=>UPLOADED_PATH,
        '%root:path%'=>SITE_PATH
    );

$dir = dirname ( realpath ( __FILE__ ) ).DIRECTORY_SEPARATOR."plugin".DIRECTORY_SEPARATOR;
if ($dh = opendir($dir)) {
    while (($file = readdir($dh)) !== false) {
        if($file!='.' && $file!='..' && filetype($dir . $file)!='dir') {
            include($dir.$file);
            if(strpos($file, "hack_")!== false)
                $_SESSION[SYNTAX_WORD][]= substr(basename($file, ".php"),5);
                else
                $_SESSION[SYNTAX_WORD][]= basename($file, ".php");
        }
    }
    closedir($dh);
}

function do_syntax($text) {
    $text=include_template($text);
    foreach($_SESSION[SYNTAX_WORD] as $v) {
        if(strpos($text,"[".$v.":")!==false)
            $x_pos[$v]=strpos($text,$v);
    }
    if(!count($x_pos)) return $text;
    asort($x_pos);
    $FK=array_keys($x_pos);
    $text=START_SYNTAX($text,$FK[0]);
    return $text;
}

function START_SYNTAX($text,$WORD) {
    $start="[{$WORD}:";$end="end {$WORD}]";
    $x=extractBetweenDelimetersx($text,$start,$end);
    $x1= str_replace('","', "^|^", $x);
    $eval="SYNTAX_$WORD";
    $x1=$eval(reverse_strrchr(reverse_strrchr($x1, '"',1),'"'));
    $text=str_replace($start.$x.$end,$x1,$text);
    $text=include_template($text);
    $text=do_syntax($text);
    return $text;
}

function extractBetweenDelimetersx($inputstr,$delimeterLeft,$delimeterRight,$i=1) {
    $posLeft  = strpos($inputstr,$delimeterLeft);
    $posRight = strnpos($inputstr,$delimeterRight,$i);
    if($posLeft===false || $posRight===false) if($posLeft===false) die("Error:<br> near $delimeterLeft  _ !$posLeft || !$posRight _ <hr> $inputstr "); else die("Error:<br> near $delimeterRight _ !$posLeft || !$posRight _<hr> $inputstr ");
    $cut_text = substr($inputstr,$posLeft+ strlen($delimeterLeft),$posRight-($posLeft+ strlen($delimeterLeft)));
    $i++;
    if($i==10) exit();
    if(strnpos($cut_text,$delimeterLeft,$i-1)>0) return extractBetweenDelimetersx($inputstr,$delimeterLeft,$delimeterRight,$i); else
        return  $cut_text;
}

function reverse_strrchr($haystack, $needle, $trail=0) {
    if($trail) return substr($haystack, 0, strrpos($haystack, $needle)) ;
    else       return substr($haystack, strpos($haystack, $needle)+1) ;
}

function strnpos($haystack, $needle, $nth, $offset = 0) {
    if(!$haystack) return ""; else {
        for ($retOffs=$offset-1; ($nth>0)&&($retOffs!==FALSE); $nth--) $retOffs = strpos($haystack, $needle, $retOffs+1);
        return $retOffs;
    }
}

function check_syntax($template,$vars) {
    $x=str_replace('^|^','","',substr($template, strnpos($template, '^|^', $vars)+3));
    return $x;
}

function include_template($template) {
    global $template_name;
    while (preg_match('/{%template:([a-zA-Z0-9._-]+)\.inc%}/',$template)) {
        $pattern = '/{%template:([a-zA-Z0-9._-]+)\.inc%}/';
        preg_match_all($pattern, $template, $matches);
        foreach($matches[1] as $var_k => $var_v) $matches[1][$var_k]=$template_name[$var_v];
        $template = str_replace($matches[0], $matches[1] , $template);
    }
    $template=change_path($template);
    return $template;
}
function change_path($template) {
    $in=array_keys($_SESSION['all_paths_replace']);
    return  str_replace($in, $_SESSION['all_paths_replace'] , $template);
}
?>